# this python progrm is writen for the extraction of database searching result. 
# The input file format is xml

import os
import re

# the following information need to be saved
# 1. peptide sequence
# 2. scan of ms/ms spectrum from which it is identified
# 3. various of scores: xcorr, deltacn, deltacnstar, spscore and sprank
# 4. modification list format in (type, number)

# define the functions to be used in this script
def ExtractAndSave(FileName):
    # this file is writen to extract the desired information
    file_reader = open(FileName, 'r')
    file_name = os.path.basename(FileName)
    file_name = file_name.rstrip(".xml")
    save_file_name = file_name + "_info.txt"
    # save the file
    file_writer = open(save_file_name, 'w')
    save_file_name = file_name + "_seq.txt"
    file_writer1 = open(save_file_name, 'w')
    
    # begin to parse xml file and extract the desired information
    # obtain the modification list
    modification_list = {}
    save_result_str = ''
    save_seq = ''
    peptide_modify_list = {}
    for each_line in file_reader.readlines():
        read_str = each_line.rstrip("\n")
        if read_str.find("aminoacid_modification") != -1:
            # find a modification
            regex = '"(\d+\.\d+)".*"(\d+\.\d+)"'
            search_result = re.search(regex, read_str)
            if search_result:
                mass_value = int(float(search_result.group(2)))
                mass_diff = search_result.group(1)
                modification_list[mass_value] = mass_diff
        # read the begin and the scan of the peptide
        if read_str.find('<spectrum_query') != -1:
            regex = 'start_scan="(\d+)"'
            search_result = re.search(regex, read_str)
            if search_result:
                save_result_str = search_result.group(1)
            regex = 'assumed_charge="(\d)"'
            search_result = re.search(regex, read_str)
            if search_result:
                save_result_str += "\t" + search_result.group(1)
        # read peptide sequence
        if read_str.find('<search_hit') != -1:
            regex = 'peptide="(\w+)"'
            search_result = re.search(regex, read_str)
            if search_result:
                save_seq = search_result.group(1)
        if read_str.find('<mod_aminoacid_mass') != -1:
            regex = 'mass="(\d+\.\d+)"'
            search_result = re.search(regex, read_str)
            if search_result:
                mass_value = int(float(search_result.group(1)))
                if peptide_modify_list.has_key(mass_value) == False:
                    peptide_modify_list[mass_value] = 1
                else:
                    peptide_modify_list[mass_value] += 1
        if read_str.find('<search_score') != -1:
            regex = 'value="(\d+\.?\d*)"'
            search_result = re.search(regex, read_str)
            if search_result:
                save_result_str += "\t" + search_result.group(1)
        if read_str.find('</spectrum_query') != -1:
            #save the result
            for each_key in modification_list:
                if peptide_modify_list.has_key(each_key) == True:
                    save_result_str += "\t" + modification_list[each_key] + "\t" + str(peptide_modify_list[each_key])
                else:
                    save_result_str += "\t" + modification_list[each_key] + "\t" + str(0)
            save_result_str += "\n"
            file_writer.write(save_result_str)
            save_result_str = ""
            peptide_modify_list.clear()
            file_writer1.write(save_seq + "\n")
            save_seq = ""
    
    file_reader.close()
    file_writer.close()
    file_writer1.close()

# obtain the xml file list
file_list = os.listdir('.')
xml_file_list = []
for each_file in file_list:
    if each_file.find(".xml") != -1:
        # this file is the xml file
        xml_file_list.append(each_file)

if len(xml_file_list) == 0:
    print "There is no database searching result in the current directory..."
    print "Press <Enter> to exit"
    raw_input()
    exit
        
        
# begin to extract and save information for each file
for each_file in xml_file_list:
    print each_file
    ExtractAndSave(each_file)

# generate reference
# obtain the file list in the current directory
all_file_list = os.listdir('.')
# obtain the file list that need to be analyzed
file_list = []
for each_file in all_file_list:
    if each_file.find('seq.txt') != -1:
        file_list.append(each_file)
        
# dict for peptides
dict_combine_peptide={}
dict_value = 1

for each_file in file_list:
    print each_file
    file_reader = open(each_file, 'r')
    for each_line in file_reader.readlines():
        key_name = each_line.rstrip('\n')
        if dict_combine_peptide.has_key(key_name) == False:
            dict_combine_peptide[key_name] = dict_value
            dict_value += 1
    file_reader.close()
    
# generate peptide reference for each database search result
for each_file in file_list:
    file_reader = open(each_file, 'r')
    save_index = []
    for each_line in file_reader.readlines():
        key_name = each_line.rstrip('\n')
        save_index.append(dict_combine_peptide[key_name])
    file_reader.close()
    file_base_name = each_file.rstrip('seq.txt')
    file_save_name = file_base_name + 'refer.txt'
    file_writer = open(file_save_name, 'w')
    for each_item in save_index:
        file_writer.write(str(each_item) + "\n")
    file_writer.close()

print "Press <Enter> to exit"
raw_input()
    
