function [MZList, IntensityList, MsLevel]=GetScanOfMZXML(ScanIndex, ScanOffset, Precision, FileID)
%file id refers to the file that's opened
%If other information is needed, add code
%In the following indicator.
if ScanIndex > length(ScanOffset)
    disp('Input scan overlow');
    return;
end

data_offset = ScanOffset(ScanIndex);
fseek(FileID, data_offset, 'bof');

while 1
    read_line = fgetl(FileID);
    if ~ischar(read_line)
        break;
    end
    % Indicator
    % Add code here if other information is needed to
    % be gotten from mzXML file
    matched = findstr(read_line, 'msLevel');
    if ~isempty(matched)
        matched = findstr(read_line, '"');
        MsLevel = str2num(read_line(matched(1)+1:matched(2)-1));
    end
    
    matched = findstr(read_line, '</peaks>');
    if ~isempty(matched)
        separator1 = findstr(read_line, '>');
        separator2 = findstr(read_line, '<');
        encode_str = read_line(separator1(1)+1:separator2(end)-1);
        [MZList, IntensityList] = DecodeData(encode_str, Precision);
        if length(MZList) > length(IntensityList)
            MZList(end)=[];
        elseif length(MZList) < length(IntensityList)
            IntensityList(end)=[];
        end
        break;
    end
end
return;

function [MZValue, IntensityValue]=DecodeData(EncodeContent, Precision)
decoder=org.apache.axis.encoding.Base64();
decode_content = decoder.decode(EncodeContent);

switch Precision
    case 32
        convert_result = typecast(decode_content, 'single');
    case 64
        convert_result = typecast(decode_content, 'double');
    otherwise 
        disp('Error precision');
        MZValue=[];
        IntensityValue = [];
        return;
end

[comp,maxsize,endian]=computer;
if endian == 'L'
    convert_result = swapbytes(convert_result);
end

MZValue = convert_result(1:2:end);
IntensityValue = convert_result(2:2:end);

return;